<?php
  class Rechnung{
    private $id; private $datum; private $kunde; private $rabatt; // in %
    private $bezahlt=FALSE; 
    private $positionen=Array(); private $anzPositionen=0;

    public function __construct($id,$datum,$kunde,$rabattGesamt,
                                            $artikel,$menge,$rabattPos1){
      $this->id=$id; $this->datum=$datum; $this->kunde=$kunde;
      $this->rabatt=$rabattGesamt;
      $this->positionen[0]=new Rechnungsposition($artikel,
                                                     $menge,$rabattPos1);
      $this->anzPositionen=1;
      $kunde->addRechnung($this);
    }

    public function getID(){
      return $this->id;
    }
    public function getDatum(){
      return $this->datum;
    }
    public function getKunde(){
      return $this->kunde;
    }
    public function getRabatt(){
      return $this->rabatt;
    }
    public function getBezahlt(){
      return $this->bezahlt;
    }
    public function getGesamtsumme(){
      $summe=0.0;
      foreach ($this->positionen as $index => $wert){
        $summe+=($wert->getGesamtpreis());
      }
      $summe=$summe*(1-($this->rabatt)/100);
      return $summe;
    }
    public function getPositionen(){
      $i=0; $position=Array();
      foreach ($this->positionen as $index => $p){
        $position[$i][0]=$p->getArtikel();
        $position[$i][1]=$p->getMenge();
        $position[$i][2]=$p->getRabatt();
        $position[$i][3]=$p->getEP();
        $position[$i][4]=$p->getGesamtpreis();
        $i++;
      }
      return $position;
    }

    public function setBezahlt($bezahlt){
      if ($bezahlt==TRUE){
        $this->bezahlt=TRUE;
      }
      else{
        $this->bezahlt=FALSE;
      }
    }

    public function addPosition($artikel,$menge,$rabattPos){
      $this->positionen[$this->anzPositionen]=new 
                           Rechnungsposition($artikel,$menge,$rabattPos);
      $this->anzPositionen++;
    }
  }

?>
