<?php
  class AirlineReservierung implements iFlugreservierung{
    // 0:init, 1:reserviert, 2:gebucht, 3:storniert
    private $zustand;
   
    public function __construct(){
      $this->zustand=0;
    }
    
    public function getZustand(){
      switch($this->zustand){
        case 0:
          return 'initialisiert'; break;
        case 1:
          return 'reserviert'; break;
        case 2:
          return 'gebucht'; break;
        case 3:
          return 'storniert'; break;
        default:
          return 'FEHLER: Ungltiger Zustand!'; break;
      }
    }
    
    public function reservieren(){
      if ($this->zustand!=0){
        throw new Fehler(20,'Reservieren im Zustand '.$this->getZustand()
                                .' nicht erlaubt!','Reservierung',FALSE);
      }
      $this->zustand=1; // reserviert
    }
    
    public function stornieren(){
      if ($this->zustand!=1){
        throw new Fehler(21,'Stornieren im Zustand '.
             $this->getZustand().' nicht erlaubt!','Reservierung',FALSE);
      }
      $this->zustand=3; // storniert
    }
    
    public function buchen(){
      if ($this->zustand!=1){
        throw new Fehler(22,'Buchen im Zustand '.$this->getZustand().
                                 ' nicht erlaubt!','Reservierung',FALSE);
      }
      // es ist Zufall, ob die Buchung funktioniert...
      srand(microtime()*1000000);
      $zufall=rand(0,2);
      if ($zufall>1){
        $this->zustand=3; // gebucht
      }
      else{
        $this->zustand=2; // storniert
      }
    }
  }
?>
