<?php
  class Aktienbestand{
    private $aktie;
    private $aktBestand=0; // aktuelle Anzahl an Aktien
    private $kaufDatumMW=FALSE;
    private $kaufPreisMW=0.0; // Kurs der Aktie beim Kauf
    private $kaufGebhren;
    private $dividenden=0.0; // zustzlich erhaltene Dividenden
    private $verkaufGebhren=0.0;
    private $verkauft=FALSE; // Bestand komplett verkauft?

    public function __construct($aktie,$kauforder,$verkaufGebhren){
      if (($aktie instanceof Aktie)==FALSE){
        throw new Exception("__construct:Sie mssen ein Aktien-Objekt 
                                                           bergeben!");
      }
      $this->setAktie($aktie);
      $this->addKauforder($kauforder);
      $this->setVerkaufGebhren($verkaufGebhren);
    }

    public function getAktie(){
    	return $this->aktie;
    }
    private function setAktie($value){
    	$this->aktie=$value;
    }

    public function getVerkaufGebhren(){
      return $this->verkaufGebhren;
    }
    private function setVerkaufGebhren($value){
      if ($this->isVerkauft()){
        throw new Exception("setVerkaufGebhren:Bestand ist bereits 
                                                          geschlossen!");
      }
      $this->verkaufGebhren=$value;
    }

    public function addDividende($value){
      if ($this->isVerkauft()){
        throw new Exception("addDividende:Bestand ist bereits 
                                                          geschlossen!");
      }
      $this->dividenden+=$value;
    }
    public function getDividenden(){
      return $this->dividenden;
    }

    public function getEkDatum(){
      return $this->kaufDatumMW;
    }

    public function getEkEinzelpreis(){
      return $this->kaufPreisMW;
    }

    public function getKaufGebhren(){
      return $this->kaufGebhren;
    }
    
    public function getAnzahl(){
      return $this->aktBestand;
    }

    public function isVerkauft(){
      return $this->verkauft;
    }

    public function addKauforder($value){
      if ($this->isVerkauft()){
        throw new Exception("addVerkauforder:Bestand ist bereits
                                                          geschlossen!");
      }
      // arithm. gewichteter Mittelwert des EK-Preises berechnen
      if ($this->kaufPreisMW==0.0){
        // 1. Kauf
        $this->kaufPreisMW=$value->getEinzelpreis();
        $this->kaufDatumMW=$value->getDatum();
      }
      else{
        // n. Kauf
        $anz1=$this->aktBestand; $ep1=$this->kaufPreisMW;
        $d1=$this->kaufDatumMW;
        $anz2=$value->getAnzahl(); $ep2=$value->getEinzelpreis();
        $d2=$value->getDatum();
        $g=$anz2/($anz1+$anz2);
        $this->kaufPreisMW=$ep1+$ep1*$g;
        $anzTage=(strtotime($d2)-strtotime($d1))/86400;
        $Dx=date_add(new DateTime($d1), 
                         new DateInterval('P'.round($g*$anzTage,0).'D'));
        $this->kaufDatumMW=$Dx->format("d.m.Y");
      }
      $this->aktBestand+=$value->getAnzahl();
      $this->kaufGebhren+=$value->getGebhr();
    }
  }
?>
