<?php
  class Bilanz{
    private $bestand=NULL;
    private $verkauf=NULL;
    
    public function __construct($bestand,$verkauf){
			$this->bestand=$bestand;
			$this->verkauf=$verkauf;
    }
    
    private function ermittelnAktuelleDaten(){
    	$ret=array();
    	// Homepage auslesen
			$handle = fopen ($this->bestand->getAktie()->getURL(), "r");
			$data="";
			while (!feof($handle)) $data .= fgets($handle, 4096);
			fclose ($handle); 
			// Kurs auslesen
			// ACHTUNG: Zugriff wurde mitlerweile gendert -> der Homepage-Parser muss berarbeitet werden!
			$search='<td class="column-datavalue2 last strong">';
			$pos1=0;
			$pos1=strpos($data,$search,1);
			if ($pos1>0)
				$ret[Kurs]=(str_replace(",",".",substr($data,$pos1+strlen($search),5)));
			else
				$ret[Kurs]=FALSE;
			// Datum und Zeit auslesen
		  $search='<td class="column-datavalue2 last">';
			$pos2=0;
			$pos2=strpos($data,$search,$pos1+1);
			if ($pos2>0){
				$ret[Datum]=substr($data,$pos2+strlen($search),10);
				$ret[Zeit]=substr($data,$pos2+strlen($search)+11,5);
			}
			else{
				$ret[Datum]=FALSE;
				$ret[Zeit]=FALSE;
			}
			return $ret;
    }
    
    public function getDaten(){
    	$data=array();
    	$data[Aktienname]=$this->bestand->getAktie()->getName();
    	$data[AktienISIN]=$this->bestand->getAktie()->getISIN();
    	$data[anzahl]=$this->bestand->getAnzahl();
    	$data[dividenden]=$this->bestand->getDividenden();
    	$data[ekDatum]=$this->bestand->getEkDatum();
    	$data[ekGebhr]=$this->bestand->getKaufGebhren();
    	$data[ekEinzelpreis]=$this->bestand->getEkEinzelpreis();
			if ($this->bestand->isVerkauft()){
				// alles wurde bereits verkauft
				$data[aktDatum]=$this->verkauf->getDatum();
				$data[aktGebhr]=$this->verkauf->getGebhr();
				$data[aktEinzelpreis]=$this->verkauf->getEinzelpreis();
			}
			else{
			  // $verkauf wren die aktuellen Verkaufsgebhren
				$akt=$this->ermittelnAktuelleDaten();
    	  $data[aktDatum]=$akt[Datum];
				$data[aktGebhr]=$verkauf;
    	  $data[aktZeit]=$akt[Zeit];
    	  $data[aktEinzelpreis]=$akt[Kurs];
			}
    	$data[tageImBesitz]=(strtotime($data[aktDatum])-strtotime($data[ekDatum]))/86400;
    	$data[ekSumme]=$data[ekEinzelpreis]*$data[anzahl]+$data[ekGebhr]; // incl. Kosten
    	$data[aktSumme]=$data[aktEinzelpreis]*$data[anzahl]-$data[aktGebhr]; // incl. Kosten
			$data[diffAktieEur]=$data[aktEinzelpreis]-$data[ekEinzelpreis]; // ohne Kosten
			$data[diffAktieProz]=($data[aktEinzelpreis]/$data[ekEinzelpreis]-1)*100; // ohne Kosten
    	$data[gewinnEur]=$data[aktSumme]-$data[ekSumme]+$data[dividenden];  	
    	$data[gewinnProz]=$data[gewinnEur]/$data[ekSumme]*100;
    	$data[gewinnProzProJahr]=100*($data[gewinnEur]/$data[tageImBesitz]*365.25)/$data[ekSumme];
    	if ($data[gewinnProzProJahr]<0) $data[gewinnProzProJahr]=0;
    	return $data;
    }
  }
?>